'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actions = require('./actions');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Authentication = function Authentication(Component) {
  var AuthComponent = (function (_Component) {
    _inherits(AuthComponent, _Component);

    function AuthComponent(props) {
      _classCallCheck(this, AuthComponent);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(AuthComponent).call(this, props));
    }

    _createClass(AuthComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.authenticate();
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.authenticate();
      }
    }, {
      key: 'authenticate',
      value: function authenticate() {
        var _props = this.props;
        var dispatch = _props.dispatch;
        var isAuthenticated = _props.isAuthenticated;

        if (isAuthenticated) {
          return;
        }
        dispatch((0, _actions.go2Login)());
      }
    }, {
      key: 'render',
      value: function render() {
        return this.props.isAuthenticated ? _get(Object.getPrototypeOf(AuthComponent.prototype), 'render', this).call(this) : null;
      }
    }]);

    return AuthComponent;
  })(Component);

  return AuthComponent;
};

exports.default = Authentication;